import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

import java.awt.*;
import java.awt.geom.Rectangle2D;
import java.awt.font.FontRenderContext;
import java.awt.geom.AffineTransform;
/**
 * Write a description of class PaintWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PaintWorld extends World
{
    greenfoot.MouseInfo mouse;
    
    int help = 30;
    
    
    public Color[][] rainbow = { // Color sequence for a rainbow
        {Color.RED, averageColor(new Color[]{Color.RED, Color.YELLOW})},
        {averageColor(new Color[]{Color.RED, Color.YELLOW}), Color.YELLOW},
        {Color.YELLOW, Color.GREEN},
        {Color.GREEN, Color.BLUE},
        {Color.BLUE, new Color(160, 32, 240)},
        
        {new Color(160, 32, 240), Color.RED},
        
        {Color.RED, averageColor(new Color[]{Color.RED, Color.YELLOW})},
        {averageColor(new Color[]{Color.RED, Color.YELLOW}), Color.YELLOW},
        {Color.YELLOW, Color.GREEN},
        {Color.GREEN, Color.BLUE},
        {Color.BLUE, new Color(160, 32, 240)},
        
        {new Color(160, 32, 240), Color.RED},
        
    };
    
    //String for help button
    public static String button = "Help";
    
    //string for guide
    public static String[] guide = {
            "HOW TO USE THE APP:",
            "Draw: Left button.",
            "Use screenshot to save your image.",
            "",
            "CHANGE BRUSH SIZE",
            "Increase size: Arrow up.",
            "Decrease size: Arrow down.",
            "",
            "CHANGE COLOR BY RED, GREEN, BLUE",
            "Increase red: U.",
            "Decrease red: J.",
            "",
            "Increase green: I.",
            "Decrease green: K.",
            "",
            "Increase blue: O.",
            "Decrease blue: L.",
            "",
            "COLOR SHORTCUTS",
            "White : W.",
            "Red: R.",
            "Green: G.",
            "Blue: B.",
            "Yellow: y.",
            "",
            "OTHER COMMANDS",
            "Get color of current tile: Right mouse.",
            "Get average color: A + right mouse.",
            "",
            "Press the \"" + button + "\" button to dismiss."
        };
    
    //the class' image
    public GreenfootImage image;
    
    //image dimensions for other classes
    public GreenfootImage infoBar = image = new GreenfootImage(getWidth(), 60);
    public GreenfootImage guideWindow = new GreenfootImage(300, getHeight() - infoBar.getHeight());
    
    //draw area variables
    public int drawArea = 30;
    public int minDrawArea = 1;
    public int maxDrawArea;
    
    //the color to draw with
    public Color color = getRandomColor();
    
    //standardized colors for layout
    public static final Color fill = new Color(155,155,225);//new Color(255, 215, 0);//new Color(230, 132, 240);//new Color(197, 197, 197); // blue/gray  159,182,205
    public static final Color text = new Color(0, 0, 0); // black
    public static final Color frame = new Color(50, 50, 50); // black/gray
    public static final Color buttonFill = new Color(125,105,165); // lignt blue
    
    // App states.
    public States state = States.START_MENU;
    public enum States {
        START_MENU,
        UPDATING,
        RUNNING
    }
    
    // Start settings.
    public StartWays start = StartWays.BLANK;
    public enum StartWays { 
        RAINBOW,
        BLACK_TO_WHITE,
        BLANK
    }
    
    /**
     * Constructor for objects of class PaintWorld.
     * 
     */
    public PaintWorld()
    {    
        //super(600, 400, 1); 
        super(792, 600, 1);
        
        //define max draw area (for brush)
        if(getWidth() > getHeight()){
            maxDrawArea = getHeight();
        }else{
            maxDrawArea = getWidth();
        }
        
        addObject(new Menu(), getWidth() / 2, getHeight() / 2);
        
        image = new GreenfootImage(getWidth(), getHeight());
        setBackground(image);
    }
    
    /**
     * Called by the Menu to trigger world creation.
     */
    private void addWorld(){
        //makes image
        switch(start){
            case RAINBOW:
                drawRainbow(image, rainbow);
                break;
            case BLACK_TO_WHITE:
                drawColorFloatVertical(image, Color.WHITE, Color.BLACK, 0, getWidth());
                break;
            case BLANK:
                image.setColor(Color.WHITE);
                image.fill();
                break;
        }
        //setImage
        
        //add objects
        addObject(new Cursor(), 20, 20);
        addObject(new InfoBar(), getWidth() / 2, infoBar.getHeight() / 2);
        addObject(new ButtonGuide(), getWidth() - 250, infoBar.getHeight() / 2);
        addObject(new Diagram(), getWidth() - 75, infoBar.getHeight() / 2);
    }
    
    /**
     * Executes all draw logic
     */
    public void act(){
        mouse = Greenfoot.getMouseInfo();
        
        if(state == States.UPDATING) {
            
            addWorld();
            state = States.RUNNING;
            
        } else if (state == States.RUNNING){
            // Draw area size adjust.
            drawArea = drawArea + adjustNumber("up", "down", 2);
            if(drawArea < minDrawArea) drawArea = minDrawArea;
            if(drawArea > maxDrawArea) drawArea = maxDrawArea;
        
            //Color RGB adjust.
            if(Greenfoot.isKeyDown("u") || Greenfoot.isKeyDown("j") || Greenfoot.isKeyDown("i") || Greenfoot.isKeyDown("k") || Greenfoot.isKeyDown("o") || Greenfoot.isKeyDown("l")){
                int r = color.getRed() + adjustNumber("u", "j", 1);
                int g = color.getGreen() + adjustNumber("i", "k", 1);
                int b = color.getBlue() + adjustNumber("o", "l", 1);
                
                color = new Color(limitForRGB(r), limitForRGB(g), limitForRGB(b));
            }
            
            // Color key commands.
            if(Greenfoot.isKeyDown("w")) color = Color.WHITE;
            if(Greenfoot.isKeyDown("r")) color = Color.RED;
            if(Greenfoot.isKeyDown("g")) color = Color.GREEN;
            if(Greenfoot.isKeyDown("b")) color = Color.BLUE;
            if(Greenfoot.isKeyDown("y")) color = Color.YELLOW;
        
            
            
            if(mouse != null){
                 
                //draw
                image.setColor(color);
                if(mouse.getY() > infoBar.getHeight()){
                
                    //get color from current tile
                    if(mouse.getButton() == 3 && Greenfoot.isKeyDown("a")){
                        help++;
                        if(help > 3){
                            help = 0;
                            Color[] list = {image.getColorAt(mouse.getX(), mouse.getY()), color};
                            color = averageColor(list);
                        }
                    }else if(mouse.getButton() == 3){ 
                        color = image.getColorAt(mouse.getX(), mouse.getY());
                    }
                    //draw figure
                    if(mouse.getButton() == 1){ 
                        image.fillOval(mouse.getX() - drawArea / 2, mouse.getY() - drawArea / 2, drawArea, drawArea);  
                    }
                }
            
                setBackground(image);
            }
        }
    }
    
    /**
     * draw a set of strings as a vertical text.
     */
    private void printString(String[] guide, int x, int y){
        image.setColor(Color.BLACK);
        for (int i = 0; i < guide.length; i++) {
            image.drawString(guide[i], x, y + i * 17);
        }
    }
    
    /**
     * Increase or decrease a number using two buttons.
     */
    private int adjustNumber(String encrease, String decrease, int speed)
    {
        int send = 0;
        
        if(Greenfoot.isKeyDown(encrease)) send = speed;
        if(Greenfoot.isKeyDown(decrease)) send = speed * -1;
        
        return send;
    }
    
    /**
     * Limit a number for use in color codes.
     */
    private int limitForRGB(int number){
        if(number > 255){ 
            number = 255;
        }else if(number < 0){
            number = 0;
        }
        return number;
    }
    
    /**
     * Calculate the average color of a list of colors.
     */
    public Color averageColor(Color[] colors){
        int red = 0;
        int green = 0;
        int blue = 0;
        for (int i = 0; i < colors.length; i++) {
            red = red + colors[i].getRed();
            green = green + colors[i].getGreen();
            blue = blue + colors[i].getBlue();
        }
        red = red / colors.length;
        green = green / colors.length;
        blue = blue / colors.length;
        
        return new Color(red, green, blue);
    }
    
    /**
     * Draw a centered text. Good for headings.
     */
    public void drawTextMiddle(GreenfootImage image, String[] draw, int x, int y){
        for(int i = 0; i < draw.length; i++){
            
            int width = getStringLengthInPixels(draw[i]);
        
            int newx = x - (int)(width / 2);
            image.drawString(draw[i], newx, y + i * 17);
        }
    }
    
    /**
     * Draw a left-centered text. Good for text.
     */
    public void drawTextLeft(GreenfootImage image, String[] draw, int x, int y){
        for(int i = 0; i < draw.length; i++){
            image.drawString(draw[i], x, y + i * 17);
        }
    }
    
    /**
     * Draw a right-centered text. Also good for headings.
     */
    public void drawTextRight(GreenfootImage image, String[] draw, int x, int y){
        for(int i = 0; i < draw.length; i++){
            drawStringRight(image, draw[i], x, y + i * 17);
        }
    }
    
    public void drawStringRight(GreenfootImage image, String draw, int x, int y){
        image.drawString(draw, x - getStringLengthInPixels(draw), y);
    }
    
    public void drawStringMiddle(GreenfootImage image, String draw, int x, int y){
        
        int width = getStringLengthInPixels(draw);
        
        int newx = x - (int)(width / 2);
        image.drawString(draw, newx, y);
    }
    
    public int getStringLengthInPixels(String string) {
        // Measure the length of the string in the current font
        FontRenderContext fontContext = new FontRenderContext(
            new AffineTransform(), true, true);
            
        Rectangle2D dimen = image.getFont().getStringBounds(string, 0, string.length(), fontContext);
        return (int)dimen.getWidth();
    }
    
    public void drawRainbow(GreenfootImage image, Color[][] colors){
        for(int i = 0; i < colors.length; i++){
            drawColorFloatVertical(image, colors[i][0], colors[i][1],i * getWidth() / colors.length,getWidth() / colors.length);
        }
    }
    
    public void drawColorFloatVertical(GreenfootImage image, Color start, Color end, int x, int length){
        for(int i = 0; i < length; i++){
            image.setColor(calcColor(start, end, length, i));
            image.drawLine(i + x, 0, i + x, getHeight());
        }
    }
    
    /**
     * Used to make a horizontal float from one color to another over the span of "length" at the position of "y".
     */
    public void drawColorFloatHorizontal(GreenfootImage image, Color start, Color end, int y, int length){
        for(int i = 0; i < length; i++){
            image.setColor(calcColor(start, end, length, i));
            image.drawLine(0, i + y, getWidth(), i + y);
        }
    }
    
    private Color calcColor(Color start, Color end, int resolution, int index){
 
        index = index % resolution;
        
        float diffRed = end.getRed() - start.getRed();
        float diffGreen = end.getGreen() - start.getGreen();
        float diffBlue = end.getBlue() - start.getBlue();
              
        int red = (int)((diffRed / (float)resolution) * (float)index) + start.getRed();
        int green = (int)((diffGreen / (float)resolution) * (float)index) + start.getGreen();
        int blue = (int)((diffBlue / (float)resolution) * (float)index) + start.getBlue();
       
        if(red > 255) red = 255;
        if(green > 255) green = 255;
        if(blue > 255) blue = 255;
        
        //System.out.println(red + "," + green + "," + blue + " idx:" + index);
       
        return new Color(red, green, blue);
    }
    
    /**
     * Returns the color to draw with
     */
    public Color getCurrentColor(){
        return color;
    }
    
    public static Color getRandomColor(){
        return new Color(Greenfoot.getRandomNumber(255), Greenfoot.getRandomNumber(255), Greenfoot.getRandomNumber(255));
    }
}
